--[[
  ****************************************************************
	GLock - Resist Calculator
	GUI Handling, Basic Functions, and Initialization
	
	Written by Ogdin of the Deathreaver Legion.  Shadow Moon
	Contact via posts at http://www.atlantic-orcs.org/


	****************************************************************]]


function GLOCK_version()

GLOCK_Config["VER"]="1.0"
DEFAULT_CHAT_FRAME:AddMessage("GLOCK Resist Calculator Loaded")

end

function GLOCK_test(a)
--/gltest

end


function GLOCK_Initialize()

	GLFACTORS={.3, .2, .1, .05, .025, .01, .008, .005}
	GLCUSPS={0,30,40,60,100,150,200,500}
	SchoolsR={.9, .9, 1, .9, .4, 0}
	SchoolsG={.7, .9, 1, .5,  1, 0}
	SchoolsB={.9, .7, 1, .4, .4, 0}
	GLNewColor="Arcane";

	GLOCK_factor=GLFACTORS[1]

	GLData1={}
	GLData2={}
	for i=1,85 do GLData1[i]=.01 GLData2[i]=6 end
	for ii=1,85 do getglobal("GG"..ii):SetPoint("BOTTOMLEFT",GLOCK_graph,"BOTTOMLEFT",(ii-1)*2+5,7) end
	GLGraphicsFlag=0
	GLNewData=0
	GLt=.001

	GLOCK_MINTIP="";
	GLOCK_TIME=0;


	GLOCK_UIschools={"Arcane","Fire","Frost","Nature","Shadow"};	--FOR UI COMPONENT INDEXING (must stay in english)


	GLOCK_frame:Hide();
		
	if not MobResistDB then
		MobResistDB	= {	}
	end

	
	for i=1,9 do getglobal("GLOCKSearch_B"..i):Hide() end

	-- Add Slash Commands

	SlashCmdList["GLOCKVER"] = GLOCK_version;
	SLASH_GLOCKVER1 = "/glockver";
	
	SlashCmdList["GLOCK"] = glconfig;
	SLASH_GLOCK1 = "/glock";

	SlashCmdList["GLTEST"] = GLOCK_test;
	SLASH_GLTEST1 = "/gltest";

	SlashCmdList["GLOCKLOCK"] = GLOCK_lock;
	SLASH_GLOCKLOCK1 = "/glocklock";

	GLElemPrec=0
	GLHit=0;
	GLDshadow=0;
	GLDarcane=0;
	GLDfrost=0;
	GLDfire=0;
	GLDnature=0;

	GLOCK_Target_Level=0
	GLOCK_Target_Name=""

		GLOCK_frame:Hide()
		GLOCK_minimize:Hide()
		GLOCK_confirm:Hide()

	if not GLOCK_Config then
		GLOCK_Config={ }
		GLOCK_Config["VISIBLE"]=1
		GLOCK_Config["PVP"]=0
		GLOCK_Config["AUTOLINK"]=0
		GLOCK_Config["SEARCHON"]=1
		GLOCK_Config["LOCKED"]=0
	end
		GLOCK_Config["VCHAT1"]=">"
		GLOCK_Config["VCHAT2"]=">"
		GLOCK_Config["VCHAT3"]=">"
		GLOCK_Config["VCHAT4"]=">"

	if GLOCK_Config["UISCALE"]==nil then GLOCK_Config["UISCALE"]=1 end

	GLOCK_frame:SetScale(GLOCK_Config["UISCALE"])
	GLOCK_scaleSlider:SetValue(GLOCK_Config["UISCALE"]*100)
	GLOCK_scaleSlider:SetScript("OnValueChanged",GLSliderAction)

	if GLOCK_Config["LOCKED"]==1 then GLOCK_frame:SetScript("OnMouseDown",nil) GLOCK_minimize:SetScript("OnMouseDown",nil) end

	GLOCK_config_Visible_CheckBox:SetChecked(GLOCK_Config["VISIBLE"])
	GLOCK_config_pvp_CheckBox:SetChecked(GLOCK_Config["PVP"])
	GLOCK_config_LinkOnLoad_CheckBox:SetChecked(GLOCK_Config["AUTOLINK"])
	
	GLOCK_Level_InputBox:Hide()
	GLOCK_Name_InputBox:Hide()
	GLOCK_config_SearchName_Text:Hide()
	GLOCK_config_SearchLevel_Text:Hide()
	GLOCKSearch_ScrollFrame:Hide()
	for i=1,9 do getglobal("GLOCKSearch_B"..i):Hide() end
	for i=1,9 do getglobal("GLOCKSearch_Text"..i):SetText("") end

	for i=1,5 do
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."VulnT"):Hide()
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."Vuln"):Hide()
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."H"):Hide()
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."R"):Hide()
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."M"):Hide()
	end
	GLOCKSEARCH_Tlvl:Hide()
	GLOCKSEARCH_TName:Hide()
	GLOCKSEARCH_YourHitT:Hide()
	GLOCKSEARCH_CastT:Hide()
	GLOCKSEARCH_MissT:Hide()
	GLOCKSEARCH_YourRT:Hide()
	GLOCKSEARCH_clear:Hide()

	GLOCK_Name_InputBox:SetAutoFocus(0)
	GLOCK_Level_InputBox:SetAutoFocus(0)


	this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
	this:RegisterEvent("UNIT_INVENTORY_CHANGED");
	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("UNIT_AURASTATE");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("DISPLAY_SIZE_CHANGED");
	this:RegisterEvent("UNIT_MODEL_CHANGED");
	this:RegisterEvent("CHAT_MSG_ADDON");

	GLOCK_scanGear()
	GLOCK_version()
end


-----------------------------------------------------------------
--OnUpdate Event for several UI objects
function GLOCK_chatStatus()

		--Reset net status indicator to red every 1 second
		if (math.floor(GLOCK_TIME)<math.floor(GetTime())) then 
			GMaxActivity:SetVertexColor(1,0,0);
			GMinActivity:SetVertexColor(1,0,0);
		end
		

		if GLOCK_graph:IsVisible() then
			--Draws the new data on the screen
			for ii=1,85 do getglobal("GG"..ii):SetHeight(36*(GLData1[ii])+1)  getglobal("GG"..ii.."_Background"):SetVertexColor(SchoolsR[GLData2[ii]],SchoolsG[GLData2[ii]],SchoolsB[GLData2[ii]]) end
		end

		--Execute command w/ period = GLt seconds
		if math.floor(GLOCK_TIME/GLt)<math.floor(GetTime()/GLt) then end

		GLOCK_TIME=GetTime();
end




function GLOCK_help()

DEFAULT_CHAT_FRAME:AddMessage("/glocklock - toggles locking the GLOCK UI in place")
DEFAULT_CHAT_FRAME:AddMessage("/glock - bring up the config/search panel")

end


function GLOCK_lock()
--toggles lock status
	if GLOCK_frame:GetScript("OnMouseDown")==nil then
		GLOCK_frame:SetScript("OnMouseDown",glocklockmax)
		GLOCK_minimize:SetScript("OnMouseDown",glocklockmin)
		DEFAULT_CHAT_FRAME:AddMessage("GLOCK Unlocked.")
		GLOCK_Config["LOCKED"]=0
	else
		GLOCK_frame:SetScript("OnMouseDown",nil)
		GLOCK_minimize:SetScript("OnMouseDown",nil)
		DEFAULT_CHAT_FRAME:AddMessage("GLOCK locked.")
		GLOCK_Config["LOCKED"]=1
	end

end

function glocklockmax() GLOCK_frame:StartMoving() end
function glocklockmin() GLOCK_minimize:StartMoving() end
function glconfig() GLOCK_config:Show() end

function GLSliderAction()
	GLOCK_Config["UISCALE"]=this:GetValue()/100
	GLOCK_frame:SetScale(this:GetValue()/100)
end


----------------------
-- Event Handler
-- this function parses events
function GLOCK_OnEvent()
	
	if event=="CHAT_MSG_SPELL_SELF_DAMAGE" then GLOCK_DmgParse() end
	if event=="UNIT_INVENTORY_CHANGED" then GLOCK_scanGear() end
	if event=="UNIT_AURA" then GLOCK_scanTarget() end
	if event=="UNIT_AURASTATE" then GLOCK_scanTarget() end
	if event=="PLAYER_TARGET_CHANGED" then GLOCK_scanTarget() end
	if event=="CHAT_MSG_ADDON" then GLOCK_chatHandle() end
	if event=="VARIABLES_LOADED" then GLOCK_Initialize() end
end




-----------------------------------------------------------------------------------------------------------
--Handles graphics updates for the data on screen
-----------------------------------------------------------------------------------------------------------
function GLOCK_UpdateGUI()

	if GLOCK_Config["VISIBLE"]==nil then GLOCK_frame:Hide() GLOCK_minimize:Hide() return end
	if GLOCK_Target_Name==nil then return end
	if GLOCK_Target_Level==nil then return end

	jj=0;

--COLOR LEVEL DIFFERENCE
	GLOCK_Tlvl:SetText(GLOCK_Target_Level)
	GLOCK_TName:SetText(GLOCK_Target_Name)
	if GLOCK_Target_Level>=0 then GLOCK_Tlvl:SetTextColor(.5,.5,.5) end
	if GLOCK_Target_Level>=48 then GLOCK_Tlvl:SetTextColor(.2,.9,.2) end
	if (GLOCK_Target_Level>=58 and GLOCK_Target_Level<=62) then GLOCK_Tlvl:SetTextColor(1,1,0) end
	if (GLOCK_Target_Level==63) then GLOCK_Tlvl:SetTextColor(.9,.5,.4) end
	if (GLOCK_Target_Level>63) then GLOCK_Tlvl:SetTextColor(1,.2,.2) end
	if (GLOCK_Target_Level==-1) then GLOCK_Tlvl:SetTextColor(1,.2,.2); GLOCK_Tlvl:SetText("Boss") end


	for i=1,5 do
		GLOCK_dbindex=GLOCK_Target_Name.."/"..GLOCK_Target_Level.."/"..GLOCK_schools[i]
		getglobal("GLOCK_"..GLOCK_UIschools[i].."VulnT"):Hide()
		getglobal("GLOCK_"..GLOCK_UIschools[i].."Vuln"):Hide()
		getglobal("GLOCK_"..GLOCK_UIschools[i].."H"):Hide()
		getglobal("GLOCK_"..GLOCK_UIschools[i].."R"):Hide()
		getglobal("GLOCK_"..GLOCK_UIschools[i].."M"):Hide()

	--If There is a database entry and mob is not immune or vulnerable
		if (MobResistDB[GLOCK_dbindex]~=nil and (not(MobResistDB[GLOCK_dbindex.."immune"]==1 or MobResistDB[GLOCK_dbindex.."vuln"]==1))) then 
			a=MobResistDB[GLOCK_dbindex];
			GLOCK_temp1=string.find(a,"/");	GLOCK_temp2=string.find(a,"_");	GLOCK_temp3=string.find(a,"A");	GLOCK_temp4=string.find(a,"|");
			
			GLOCK_DBMiti=tonumber(string.sub(a,1,GLOCK_temp1-1));			
			GLOCK_DBHits=tonumber(string.sub(a,GLOCK_temp1+1,GLOCK_temp2-1))
			GLOCK_DBMiss=tonumber(string.sub(a,GLOCK_temp2+1,GLOCK_temp3-1))	
			GLOCK_DBMinR=tonumber(string.sub(a,GLOCK_temp3+1,GLOCK_temp4-1))	
			GLOCK_DBi=tonumber(string.sub(a,GLOCK_temp4+1))				
			
		--CHECK FOR ERRORS
			if GLOCK_DBMiti==nil or GLOCK_DBHits==nil or GLOCK_DBMiss==nil then GLOCK_DBMiti=0; MobResistDB[GLOCK_dbindex]=nil; return end
			if GLOCK_DBMiti<0 then GLOCK_DBMiti=0; end    --Sometimes Frost resist scores appear negative in the calculation
			
		--Mitigation Interpretation
			--If approximation only involves penetration values from gear+debuffs
			--if GLOCK_DBMiti==GLOCK_DBMinR then GLOCK_DBMiti=0 end  
			--Remove the level based partial resistance Calculation from the Value
			--if GLOCK_DBMiti>GLOCK_DBMinR then GLOCK_DBMiti=GLOCK_DBMiti-2*(GLOCK_Target_Level-60) end
			--If approximation only involves penetration values from gear and level difference, then set it to zero
			--if GLOCK_DBMiti<=GLOCK_DBMinR then GLOCK_DBMiti=0 end

		--Display Resist Approximations
			GTxT=tostring(math.floor(4*GLOCK_DBMiti+.5));
			getglobal("GMin"..GLOCK_UIschools[i].."TxT"):SetText(GTxT)
			getglobal("GLOCK_"..GLOCK_UIschools[i].."R"):SetText(GTxT)
			
		--Display #Casts
			getglobal("GLOCK_"..GLOCK_UIschools[i].."H"):SetText(math.floor(GLOCK_DBHits+GLOCK_DBMiss+.5))

		--Display %Hit (avg +hit%)  (i.e. 86(3)% )
			GTxT=string.format("%.0f(%.0f)",math.floor(100*GLOCK_DBHits/(GLOCK_DBMiss+GLOCK_DBHits)+.5),GLOCK_DBi)
			getglobal("GLOCK_"..GLOCK_UIschools[i].."M"):SetText(GTxT)

		--Display Current Penetration (avg Penetration) (i.e. 75(60) )
			GTxT=string.format("%.0f(%.0f)",getglobal("GLD"..string.lower(GLOCK_UIschools[i]))+GLnegresist,GLOCK_DBMinR)
			getglobal("GLOCK_"..GLOCK_UIschools[i].."Vuln"):SetText(GTxT)
			jj=jj+1;

	--If the mob is recorded as immune or vulnerable
		elseif (MobResistDB[GLOCK_dbindex.."immune"]==1 or MobResistDB[GLOCK_dbindex.."vuln"]==1) then 
			if MobResistDB[GLOCK_dbindex.."immune"]==1 then GLSpecial="Imm" end
			if MobResistDB[GLOCK_dbindex.."vuln"]==1 then GLSpecial="Vul" end
			getglobal("GLOCK_"..GLOCK_UIschools[i].."R"):SetText(GLSpecial) 
			getglobal("GMin"..GLOCK_UIschools[i].."TxT"):SetText(GLSpecial)
			getglobal("GLOCK_"..GLOCK_UIschools[i].."H"):SetText("0")
			getglobal("GLOCK_"..GLOCK_UIschools[i].."M"):SetText("0")
			jj=jj+1;

	--If there is no data for this mob
		elseif ((not MobResistDB[GLOCK_dbindex]) and (not MobResistDB[GLOCK_dbindex.."immune"]) and (not MobResistDB[GLOCK_dbindex.."vuln"])) then
			getglobal("GMin"..GLOCK_UIschools[i].."TxT"):SetText("")
		end

	--If there is data for this mob, display the text object in the maximized window
		if MobResistDB[GLOCK_dbindex] or MobResistDB[GLOCK_dbindex.."immune"] or MobResistDB[GLOCK_dbindex.."vuln"] then
			getglobal("GLOCK_"..GLOCK_UIschools[i].."VulnT"):Show()
			getglobal("GLOCK_"..GLOCK_UIschools[i].."Vuln"):Show()
			getglobal("GLOCK_"..GLOCK_UIschools[i].."H"):Show()
			getglobal("GLOCK_"..GLOCK_UIschools[i].."R"):Show()
			getglobal("GLOCK_"..GLOCK_UIschools[i].."M"):Show()

			getglobal("GLOCK_"..GLOCK_UIschools[i].."VulnT"):SetPoint("TOPLEFT",5,-45-10*(jj-1));
			getglobal("GLOCK_"..GLOCK_UIschools[i].."Vuln"):SetPoint("TOPLEFT",25,-45-10*(jj-1));
			getglobal("GLOCK_"..GLOCK_UIschools[i].."H"):SetPoint("TOPLEFT",70,-45-10*(jj-1));
			getglobal("GLOCK_"..GLOCK_UIschools[i].."M"):SetPoint("TOPLEFT",110,-45-10*(jj-1));
			getglobal("GLOCK_"..GLOCK_UIschools[i].."R"):SetPoint("TOPLEFT",160,-45-10*(jj-1));
		end
	end

	


	if MobResistDB["UISTATE"]=="MAXIMIZED" then
		GLOCK_frame:Show()
		GLOCK_minimize:Hide()
	else
		GLOCK_frame:Hide()
		GLOCK_minimize:Show()
	end

end




-----------------------------------------------------------------------------------------------------------
--Determine the debuffs on the target or buffs on the player that add to penetration
-----------------------------------------------------------------------------------------------------------
function GLOCK_scanTarget()

	GLDshadow=0;
	GLDarcane=0;
	GLDfrost=0;
	GLDfire=0;
	GLDnature=0;

	
	--if unit is a friendly NPC, then hide glock
	if ((UnitIsFriend("Target","Player")) and (not UnitIsPlayer("Target"))) then GLOCK_frame:Hide(); GLOCK_minimize:Hide() return; end
	
	--If the unit is friendly PC and pvp is off, then hide glock
	if ((not UnitIsEnemy("Target","Player")) and (not GLOCK_Config["PVP"]) and UnitIsPlayer("Target")) then GLOCK_frame:Hide(); GLOCK_minimize:Hide() return; end

	--If PvP is off and the target is an enemy player, then hide glock		
	if ( not GLOCK_Config["PVP"] )  then
		if (UnitIsPlayer("Target") and UnitIsEnemy("Target","Player")) then GLOCK_frame:Hide(); GLOCK_minimize:Hide() return; end
	end

--ScanTarget for Resist debuffs


	GLOCK_Target_Name=UnitName("Target");
	if UnitIsPlayer("Target") then GLOCK_Target_Name="*"..UnitName("Target").."*" end
	GLOCK_Target_Level=UnitLevel("Target");
	GLOCK_YourHitT:SetTextColor(1,1,0)
	
	if not GLOCK_Target_Name then 
		GLOCK_frame:Hide();
		GLOCK_minimize:Hide()
		GLOCK_confirm:Hide()
		for i=1,5 do getglobal("GLOCK_confirm_"..GLOCK_UIschools[i]):SetChecked(1) end
		return;
	end
		

		TFury=0;

--DEBUFF SCANNING
	for i=1,16 do
		GLTooltip:ClearLines();	
		GLTooltip:SetUnitDebuff("Target",i);
		if (GLTooltipTextLeft1:GetText()==GL_COS) then GLDshadow=GLDshadow+75; GLDarcane=GLDarcane+75 end
		if (GLTooltipTextLeft1:GetText()==GL_COE) then GLDfrost=GLDfrost+75; GLDfire=GLDfire+75 end
		if (GLTooltipTextLeft1:GetText()==GL_TF and TFury==0) then GLDnature=GLDnature+25; TFury=1; end
	end


--EYE OF MOAM BUFF ON PLAYER
	for i=1,16 do
		GLTooltip:ClearLines();
		GLTooltip:SetUnitBuff("Player",i);
		if GLTooltipTextLeft1:GetText()==GL_Eye then --Eye of Moam
			GLDshadow=GLDshadow+100
			GLDarcane=GLDarcane+100
			GLDfrost=GLDfrost+100
			GLDfire=GLDfire+100
			GLDnature=GLDnature+100
		elseif GLTooltipTextLeft1:GetText()==GL_Qiraj then --Staff of the Qiraji Prophets
			GLDshadow=GLDshadow+50
			GLDarcane=GLDarcane+50
			GLDfrost=GLDfrost+50
			GLDfire=GLDfire+50
			GLDnature=GLDnature+50
		end
	end

	GLOCK_UpdateGUI()


end

-----------------------------------------------------------------------------------------------------------
--Keep track of penetration and hit chance from gear you have equipped
-----------------------------------------------------------------------------------------------------------
function GLOCK_scanGear()

--DETERMINE HOW MUCH -RESIST and +HIT gear player has on

	GLnegresist=0;
	GLhit=0;
	GLARCANISTSet=0;
	GLZANZILSet=0

	for i=1,18 do
		hasItem = GLTooltip:SetInventoryItem("player", i);
		if ( not hasItem ) then
			GLTooltip:ClearLines()
		else
			itemName = GLTooltipTextLeft1:GetText();

			lines = GLTooltip:NumLines();

			for i=2, lines do
				tmpText = getglobal("GLTooltipTextLeft"..i);
				if (tmpText:GetText()) then
					tmpStr = tmpText:GetText();

					if string.find(tmpStr,GLEQUIP_PENETRATION) then
						tmpStr=string.gsub(tmpStr,GLEQUIP_PENETRATION,"")
						tmpStr=string.sub(tmpStr,1,-2)
						GLnegresist=GLnegresist+tonumber(tmpStr);
					end
					if string.find(tmpStr,GLEQUIP_HIT) then
						tmpStr=string.gsub(tmpStr,GLEQUIP_HIT,"")
						tmpStr=string.sub(tmpStr,1,1)
						GLhit=GLhit+tonumber(tmpStr);
					elseif string.find(tmpStr,GLMAGE_ZGHIT) then    ---Mage helm/leg ZG enchant
						GLhit=GLhit+1;
					elseif string.find(tmpStr,GLARCANIST) then
						GLARCANISTSet=GLARCANISTSet+1;
					elseif string.find(tmpStr,GLZANZIL) then
						GLZANZILSet=GLZANZILSet+1;
					end
				end
			end
		end
	end	
		if GLARCANISTSet>=5 then GLnegresist=GLnegresist+10; end
		if GLZANZILSet==2 then GLhit=GLhit+1 end

--This Elemental Precision and Arcane Subtlety talent scan was written by Aelian of Theorycraft
	local _, class = UnitClass("player")
	if string.lower(class) == GLMAGE then
		_, _, _, _, GLElemPrec = GetTalentInfo(3, 3)
		GLhit = GLhit + GLElemPrec*2
		local _, _, _, _, currank = GetTalentInfo(1, 1)
		GLnegresist = GLnegresist + currank*5
	end
	

	if ((not GLDshadow) or (not GLDarcane) or (not GLDfrost) or (not GLDfire) or (not GLDnature)) then GLOCK_scanTarget() end

	GLOCK_HitP:SetText(GLhit.."% Hit")
	GLOCK_ShadowVuln:SetText(GLDshadow+GLnegresist)
	GLOCK_ArcaneVuln:SetText(GLDarcane+GLnegresist)
	GLOCK_FrostVuln:SetText(GLDfrost+GLnegresist)
	GLOCK_FireVuln:SetText(GLDfire+GLnegresist)
	GLOCK_NatureVuln:SetText(GLDnature+GLnegresist)
	GLOCK_scanTarget()

end
