--[[
  ****************************************************************
	GLock - Resist Calculator
	Database Search and Handling
	
	Written by Ogdin of the Deathreaver Legion.  Shadow Moon
	Contact via posts at http://www.atlantic-orcs.org/


	****************************************************************]]

----------------------------------------------------------------------------------
--Clears and Entry when the small x in the main window is clicked
----------------------------------------------------------------------------------
function GLOCK_ClearEntry()

	tempStr=GLOCK_CONFTXT:GetText();
	GLOCK_temp1=string.find(tempStr,"-")
	GLOCK_temp2=string.sub(tempStr,1,GLOCK_temp1-2)
	GLOCK_temp3=string.sub(tempStr,GLOCK_temp1+2)

	for i=1,5 do
		if getglobal("GLOCK_confirm_"..GLOCK_UIschools[i]):GetChecked() then
			GLOCK_dbindex=GLOCK_temp3.."/"..GLOCK_temp2.."/"..GLOCK_schools[i]
			MobResistDB[GLOCK_dbindex]=nil
			MobResistDB[GLOCK_dbindex.."immune"]=nil
			MobResistDB[GLOCK_dbindex.."vuln"]=nil
			getglobal("GLOCK_confirm_"..GLOCK_UIschools[i]):SetChecked(1)
		end
	end

	GLOCK_UpdateGUI()
	GLOCK_confirm:Hide()

end


----------------------------------------------------------------------------------
--Runs through the database looking for the search string
----------------------------------------------------------------------------------
function GLOCK_DBSearch()

	GLOCKSEARCH_continue:Show()

	for i=1,5 do
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."VulnT"):Hide()
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."Vuln"):Hide()
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."H"):Hide()
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."R"):Hide()
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."M"):Hide()
	end
	GLOCKSEARCH_Tlvl:Hide()
	GLOCKSEARCH_TName:Hide()
	GLOCKSEARCH_YourHitT:Hide()
	GLOCKSEARCH_CastT:Hide()
	GLOCKSEARCH_MissT:Hide()
	GLOCKSEARCH_YourRT:Hide()
	GLOCKSEARCH_clear:Hide()

jj=1
a=GLOCK_Name_InputBox:GetText()
b=GLOCK_Level_InputBox:GetText()
GLOCK_SearchTemp={}
currentDBindex=0;
	for index,value in pairs(MobResistDB) do
		currentDBindex=currentDBindex+1;

		GLOCK_temp1=string.find(index,"/");
		GLOCK_tmpStr="";
		if GLOCK_temp1 then
			GLOCK_temp2=string.find(index,"/",GLOCK_temp1+1)
			GLOCK_temp3=string.sub(index,1,GLOCK_temp1-1)
			GLOCK_tmpStr=string.sub(index,1,GLOCK_temp2-1)
		end
		if currentDBindex>=GLSinitIndex and (string.find(string.lower(GLOCK_tmpStr),string.lower(a)) and string.find(string.lower(GLOCK_tmpStr),string.lower(b))) then 
			GLOCK_temp1=string.find(index,"/");
			if GLOCK_temp1 then
				GLOCK_temp2=string.find(index,"/",GLOCK_temp1+1)

				GLOCK_temp3=string.sub(index,1,GLOCK_temp1-1)
				GLOCK_temp4=tonumber(string.sub(index,GLOCK_temp1+1,GLOCK_temp2-1))
				if GLOCK_temp4==-1 then GLOCK_temp4="Boss" end
					
				if jj>9 then GLSinitIndex=currentDBindex return end

				GLOCK_temp1=0;
				for indexi, valuei in ipairs(GLOCK_SearchTemp) do if string.sub(index,1,GLOCK_temp2-1)==valuei then GLOCK_temp1=1; end end
				
				if GLOCK_temp1==0 then
					getglobal("GLOCKSearch_B"..jj):Show()
					getglobal("GLOCKSearch_Text"..jj):SetText(GLOCK_temp4.." - "..GLOCK_temp3)
					GLOCK_SearchTemp[jj]=string.sub(index,1,GLOCK_temp2-1)
					jj=jj+1
				end
			end
		 end
		
	end
	if jj<=9 then for i=jj,9 do getglobal("GLOCKSearch_Text"..i):SetText("") getglobal("GLOCKSearch_B"..i):Hide() end GLOCKSEARCH_continue:Hide() end

	if jj==2 then GLOCKSEARCH_continue:Hide() GLOCK_DBSearchDisplay(1) end

end


----------------------------------------------------------------------------------
--Update the search results display GUI (and the minimized gui for theorycraft link)
----------------------------------------------------------------------------------
function GLOCK_DBSearchDisplay(a)
	
	if currentDBindex==0 then
		GLOCK_Name_InputBox:ClearFocus()
		GLOCK_Level_InputBox:ClearFocus()
		GLOCKSEARCH_continue:Hide()
	end

	
	for i=1,9 do getglobal("GLOCKSearch_Text"..i):SetText("") getglobal("GLOCKSearch_B"..i):Hide() end
	GLOCKSEARCH_Tlvl:Show()
	GLOCKSEARCH_TName:Show()
	GLOCKSEARCH_YourHitT:Show()
	GLOCKSEARCH_CastT:Show()
	GLOCKSEARCH_MissT:Show()
	GLOCKSEARCH_YourRT:Show()
	GLOCKSEARCH_clear:Show()
	

		GLOCK_temp1=string.find(GLOCK_SearchTemp[a],"/");
		GLOCK_S_Name=string.sub(GLOCK_SearchTemp[a],1,GLOCK_temp1-1)
		GLOCK_S_Level=tonumber(string.sub(GLOCK_SearchTemp[a],GLOCK_temp1+1))

	jj=0;

	for i=1,5 do
		GLOCK_dbindex=GLOCK_S_Name.."/"..GLOCK_S_Level.."/"..GLOCK_schools[i]
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."VulnT"):Hide()
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."Vuln"):Hide()
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."H"):Hide()
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."R"):Hide()
		getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."M"):Hide()


		if MobResistDB[GLOCK_dbindex]~=nil and (not (MobResistDB[GLOCK_dbindex.."immune"]==1 or MobResistDB[GLOCK_dbindex.."vuln"]==1)) then 
			a=MobResistDB[GLOCK_dbindex];
			GLOCK_temp1=string.find(a,"/");
			GLOCK_temp2=string.find(a,"_");
			GLOCK_temp3=string.find(a,"A");
			GLOCK_temp4=string.find(a,"|");
			
			GLOCK_DBMiti=tonumber(string.sub(a,1,GLOCK_temp1-1));			
			GLOCK_DBHits=tonumber(string.sub(a,GLOCK_temp1+1,GLOCK_temp2-1))
			GLOCK_DBMiss=tonumber(string.sub(a,GLOCK_temp2+1,GLOCK_temp3-1))	
			GLOCK_DBMinR=tonumber(string.sub(a,GLOCK_temp3+1,GLOCK_temp4-1))	
			GLOCK_DBi=tonumber(string.sub(a,GLOCK_temp4+1))				
			if GLOCK_DBMiti<0 then GLOCK_DBMiti=0 end
			
		--CHECK FOR ERRORS
			if GLOCK_DBMiti==nil then GLOCK_DBMiti=0; MobResistDB[GLOCK_dbindex]=nil; return end
			if GLOCK_DBHits==nil then GLOCK_DBHits=0; MobResistDB[GLOCK_dbindex]=nil; return end
			if GLOCK_DBMiss==nil then GLOCK_DBMiss=0; MobResistDB[GLOCK_dbindex]=nil; return end
			
		--Update Resist Approximations
			GTxT=tostring(math.floor(4*GLOCK_DBMiti+.5));
			getglobal("GMin"..GLOCK_UIschools[i].."TxT"):SetText(GTxT)
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."R"):SetText(GTxT)
			
		--Display #Casts
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."H"):SetText(math.floor(GLOCK_DBHits+GLOCK_DBMiss+.5))

		--Display %Hit (avg +hit%)  (i.e. 86(3)% )
			GTxT=string.format("%.0f(%.0f)",math.floor(100*GLOCK_DBHits/(GLOCK_DBMiss+GLOCK_DBHits)+.5),GLOCK_DBi)
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."M"):SetText(GTxT)

		--Display Current Penetration (avg Penetration) (i.e. 75(60) )
			GTxT=string.format("(%.0f)",math.floor(GLOCK_DBMinR+.5))
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."Vuln"):SetText(GTxT)
			jj=jj+1;


		elseif (MobResistDB[GLOCK_dbindex.."immune"]==1 or MobResistDB[GLOCK_dbindex.."vuln"]==1) then 
			if MobResistDB[GLOCK_dbindex.."immune"]==1 then GLSpecial="Imm" end
			if MobResistDB[GLOCK_dbindex.."vuln"]==1 then GLSpecial="Vul" end
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."R"):SetText(GLSpecial) 
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."H"):SetText("0")
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."M"):SetText("0")
			getglobal("GMin"..GLOCK_UIschools[i].."TxT"):SetText(GLSpecial)

			jj=jj+1;

		elseif ((not MobResistDB[GLOCK_dbindex]) and (not MobResistDB[GLOCK_dbindex.."immune"]) and (not MobResistDB[GLOCK_dbindex.."vuln"])) then
			getglobal("GMin"..GLOCK_UIschools[i].."TxT"):SetText("")

		end

		if MobResistDB[GLOCK_dbindex] or MobResistDB[GLOCK_dbindex.."immune"] or MobResistDB[GLOCK_dbindex.."vuln"] then
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."VulnT"):Show()
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."Vuln"):Show()
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."H"):Show()
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."R"):Show()
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."M"):Show()

			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."VulnT"):SetPoint("TOPLEFT",5,-45-10*(jj-1));
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."Vuln"):SetPoint("TOPLEFT",25,-45-10*(jj-1));
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."H"):SetPoint("TOPLEFT",70,-45-10*(jj-1));
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."M"):SetPoint("TOPLEFT",120,-45-10*(jj-1));
			getglobal("GLOCKSEARCH_"..GLOCK_UIschools[i].."R"):SetPoint("TOPLEFT",180,-45-10*(jj-1));
		end
	end

		GLOCKSEARCH_Tlvl:SetText(GLOCK_S_Level)
		GLOCKSEARCH_TName:SetText(GLOCK_S_Name)

		if GLOCK_S_Level>=0 then GLOCKSEARCH_Tlvl:SetTextColor(.5,.5,.5) end
		if GLOCK_S_Level>=48 then GLOCKSEARCH_Tlvl:SetTextColor(.2,.9,.2) end
		if (GLOCK_S_Level>=58 and GLOCK_Target_Level<=62) then GLOCKSEARCH_Tlvl:SetTextColor(1,1,0) end
		if (GLOCK_S_Level==63) then GLOCKSEARCH_Tlvl:SetTextColor(.9,.5,.4) end
		if (GLOCK_S_Level>63) then GLOCKSEARCH_Tlvl:SetTextColor(1,.2,.2) end
		if (GLOCK_S_Level==-1) then GLOCKSEARCH_Tlvl:SetTextColor(1,.2,.2); GLOCKSEARCH_Tlvl:SetText("Boss") end


end